<!-- $RCSfile: CQMGSTOR.TPL $ $Revision: 1.14 $ -->
<!-- Copyright (C) 1998-2001 Compaq Computer Corporation -->

<SCRIPT LANGUAGE=JavaScript>
document.write("<COMMENT>");
<!cpqIdeControllerEntry>
document.write("</COMMENT>");
<!cpqIdeIdentEntry>
<!cpqScsiCntlrEntry>
<!cpqDaCntlrEntry>
<!cpqSsChassisEntry>
<!cpqSsRaidSystemEntry>
<!cpqFcTapeCntlrEntry>
<!cpqFcaHostCntlrEntry>

<!#DAENUMS.JS>
<!#FCAENUMS.JS>
<!#MS-SCSIC.JS>
<!#MS-DACMN.JS>
<!#MS-FCCMN.JS>

function allIdeCondition()
{
   var i;  // local

   this.state = 1;    // reset to unknown

   if (typeof cpqIdeControllerEntry != "undefined") 
   {
      for (i = 0; i < cpqIdeControllerEntry.length; i++)
      {
          this.update(cpqIdeControllerEntry[i].cpqIdeControllerOverallCondition);
      }
   } else // Old IDE table
   {
      for (i = 0; i < cpqIdeIdentEntry.length; i++)
      {
          this.update(cpqIdeIdentEntry[i].cpqIdeIdentCondition);
          this.update(cpqIdeIdentEntry[i].cpqIdeIdentCondition2);
      }
   }
}

function allFcaHostCntlrCondition()
{
   var i;  // local

   this.state = 1;    // reset to unknown

   for (i = 0; i < cpqFcaHostCntlrEntry.length; i++)
   {
       this.update(cpqFcaHostCntlrEntry[i].cpqFcaHostCntlrCondition);
   }
}

function allMassStorage()
{
   var i;

   overallIdeCondition.refresh();

   overallFcaHostCntlrCondition.refresh();

   for (i = 0; i < compiledScsiCntlrCondition.length; i++)
   {
      compiledScsiCntlrCondition[i].refresh();
   }
   for (i = 0; i < compiledDaCntlrCondition.length; i++)
   {
      compiledDaCntlrCondition[i].refresh();
   }
   for (i = 0; i < compiledFcCondition.length; i++)
   {
      compiledFcCondition[i].refresh();
   }
   for (i = 0; i < compiledFcTapeCntlrCondition.length; i++)
   {
      compiledFcTapeCntlrCondition[i].refresh();
   }
   for (i = 0; i < compiledSsRaidCondition.length; i++)
   {
      compiledSsRaidCondition[i].refresh();
   }
   this.compile();
}

function compileMassStorage()
{
   var i;

   this.state = 1;    // reset to unknown

   this.update(overallIdeCondition.state);

   this.update(overallFcaHostCntlrCondition.state);

   for (i = 0; i < compiledScsiCntlrCondition.length; i++)
   {
      this.update(compiledScsiCntlrCondition[i].state);
   }
   for (i = 0; i < compiledDaCntlrCondition.length; i++)
   {
      this.update(compiledDaCntlrCondition[i].state);
   }
   for (i = 0; i < compiledFcCondition.length; i++)
   {
      this.update(compiledFcCondition[i].state);
   }
   for (i = 0; i < compiledFcTapeCntlrCondition.length; i++)
   {
      this.update(compiledFcTapeCntlrCondition[i].state);
   }
   for (i = 0; i < compiledSsRaidCondition.length; i++)
   {
      this.update(compiledSsRaidCondition[i].state);
   }
}
overallIdeCondition = new cpqCondition(1);
overallIdeCondition.refresh = allIdeCondition;

overallFcaHostCntlrCondition = new cpqCondition(1);
overallFcaHostCntlrCondition.refresh = allFcaHostCntlrCondition;

compiledScsiCntlrCondition = new Array;
for (i = 0; i < cpqScsiCntlrEntry.length; i++)
{
   compiledScsiCntlrCondition[i] = new cpqCondition(1);
   compiledScsiCntlrCondition[i].index = i;
   compiledScsiCntlrCondition[i].cntlr = cpqScsiCntlrEntry[i].cpqScsiCntlrIndex;
   compiledScsiCntlrCondition[i].bus = cpqScsiCntlrEntry[i].cpqScsiCntlrBusIndex;
   compiledScsiCntlrCondition[i].refresh = compileScsiCondition;
}
compiledDaCntlrCondition = new Array;
for (i = 0; i < cpqDaCntlrEntry.length; i++)
{
   compiledDaCntlrCondition[i] = new cpqCondition(1);
   compiledDaCntlrCondition[i].index = i;
   compiledDaCntlrCondition[i].refresh = compileDaCondition;
}
compiledFcCondition = new Array;
for (i = 0; i < cpqSsChassisEntry.length; i++)
{
   compiledFcCondition[i] = new cpqCondition(1);
   compiledFcCondition[i].index = i;
   compiledFcCondition[i].refresh = compileFcCondition;
}
compiledSsRaidCondition = new Array;
for (i = 0; i < cpqSsRaidSystemEntry.length; i++)
{
   compiledSsRaidCondition[i] = new cpqCondition(1);
   compiledSsRaidCondition[i].index = i;
   compiledSsRaidCondition[i].refresh = compileSsRaidCondition;
}
compiledFcTapeCntlrCondition = new Array;
for (i = 0; i < cpqFcTapeCntlrEntry.length; i++)
{
   compiledFcTapeCntlrCondition[i] = new cpqCondition(1);
   compiledFcTapeCntlrCondition[i].index = i;
   compiledFcTapeCntlrCondition[i].refresh = compileFcTapeCondition;
}
overallMassStorageCondition = new cpqCondition(1);
overallMassStorageCondition.refresh = allMassStorage;
overallMassStorageCondition.compile = compileMassStorage;

// refreshes and combines ide, scsi, da and fiber as well
overallMassStorageCondition.refresh();

function ideCntlrName(cntlrIdx)
{
   var cntrlName = cpqIdeControllerEntry[cntlrIdx].cpqIdeControllerModel;

   if (cpqIdeControllerEntry[cntlrIdx].cpqIdeControllerSlot > 0)
   {
      cntrlName += " in Slot " + cpqIdeControllerEntry[cntlrIdx].cpqIdeControllerSlot;
   }
   else if (cpqIdeControllerEntry[cntlrIdx].cpqIdeControllerSlot == 0)
   {
      cntrlName += " on System Board";
   }
   else // No slot number available
   {
      cntrlName += " (" + (cntlrIdx + 1) + ")";
   }
   return cntrlName;
}

navData.addTop("Mass Storage", overallMassStorageCondition.state, "/WEBAGENT/IMAGES/MASS5.GIF", true);

if (typeof cpqIdeControllerEntry != "undefined") 
{
   for (i = 0; i < cpqIdeControllerEntry.length; i++)
   {
      idePage = (1 == inFrame ? "SUBFRAME.TPL?currentSubmenu=CQMGSTOR/MS-IDMNU.TPL&" : "CQMGSTOR/MS-IDMNU.TPL?");
      idePage += "index="+cpqIdeControllerEntry[i].cpqIdeControllerIndex;
      navData.addSecondary("Mass Storage", ideCntlrName(i), idePage, 
         cpqIdeControllerEntry[i].cpqIdeControllerOverallCondition);
   }
} else // Old controller table
{
   if (cpqIdeIdentEntry.length > 0)
   {
      navData.addSecondary("Mass Storage", "IDE Devices", "CQMGSTOR/MS-IDE.TPL", overallIdeCondition.state);
   }
}

for (i = 0; i < cpqScsiCntlrEntry.length; i++)
{
   scsipage = (1 == inFrame ? "SUBFRAME.TPL?currentSubmenu=CQMGSTOR/MS-SCMNU.TPL&" : "CQMGSTOR/MS-SCMNU.TPL?");
   scsipage += "index="+cpqScsiCntlrEntry[i].cpqScsiCntlrIndex + "&bus="+cpqScsiCntlrEntry[i].cpqScsiCntlrBusIndex;
   navData.addSecondary("Mass Storage", scsiCntlrName(i), scsipage, compiledScsiCntlrCondition[i].state);
}

for (i = 0; i < cpqDaCntlrEntry.length; i++)
{
   if (typeof(cpqDaCntlrEntry[i].cpqDaCntlrCurrentRole) != "undefined")
   {
      if (cpqDaCntlrEntry[i].cpqDaCntlrCurrentRole == 4)
         continue;   // don't display backups!
   }
   daPage = (1 == inFrame ? "SUBFRAME.TPL?currentSubmenu=CQMGSTOR/MS-DAMNU.TPL&" : "CQMGSTOR/MS-DAMNU.TPL?");
   daPage += "index="+i;
   navData.addSecondary("Mass Storage", daCntlrName(i), daPage, compiledDaCntlrCondition[i].state);
}

for (i = 0; i < cpqSsChassisEntry.length; i++)
{
   fcPage = (1 == inFrame ? "SUBFRAME.TPL?currentSubmenu=CQMGSTOR/MS-FCMNU.TPL&" : "CQMGSTOR/MS-FCMNU.TPL?" );
   fcPage += "index="+i;
   navData.addSecondary("Mass Storage", fcChassisName(i), fcPage, compiledFcCondition[i].state);
}

if (cpqSsRaidSystemEntry.length > 0)
{
   raidCond = new cpqCondition();
   for (i = 0; i < cpqSsRaidSystemEntry.length; i++)
   {
      raidCond.update(cpqSsRaidSystemEntry[i].cpqSsRaidSystemCondition);
   }
   navData.addSecondary("Mass Storage", "RA-8000 RAID Array Storage Systems", "CQMGSTOR/MS-RAIDS.TPL", raidCond.state);
}

for (i = 0; i < cpqFcTapeCntlrEntry.length; i++)
{
   fctapePage = (1 == inFrame ? "SUBFRAME.TPL?currentSubmenu=CQMGSTOR/MS-FTMNU.TPL&" : "CQMGSTOR/MS-FTMNU.TPL?" );
   fctapePage += "index="+i+ "&cntlrIndex="+cpqFcTapeCntlrEntry[i].cpqFcTapeCntlrIndex;
   navData.addSecondary("Mass Storage", fcTapeCntlrName(i), fctapePage , compiledFcTapeCntlrCondition[i].state);
}

if (cpqFcaHostCntlrEntry.length > 0)
{
   navData.addSecondary("Mass Storage", "Fibre Channel Connections", "CQMGSTOR/MS-FCCON.TPL", overallFcaHostCntlrCondition.state);
}
</SCRIPT>
